import 'package:animated_splash_screen/animated_splash_screen.dart';
import 'package:firebase_core/firebase_core.dart';
import 'package:firebase_messaging/firebase_messaging.dart';
import 'package:flutter/material.dart';
import 'package:flutter_svg/flutter_svg.dart';
import 'package:get/get.dart';
import 'app_routes.dart';
import 'ssolution/lib/screen/login/login_name_screen.dart';
import 'ssolution/lib/screen/setting/private/private_change_screen.dart';

void main() async {
  WidgetsFlutterBinding.ensureInitialized();
  await Firebase.initializeApp(); // Firebase 초기화
  var token = await FirebaseMessaging.instance.getToken();
  print('token ?? ${token}');
  runApp(const MyApp());
  // runApp(
  //     GetMaterialApp(
  //       initialRoute: AppRoutes.main,
  //       getPages: AppPages.pages,
  //       builder: EasyLoading.init(),
  //       debugShowCheckedModeBanner: false,
  //     )
  // );
}

class MyApp extends StatelessWidget {
  const MyApp({super.key});

  @override
  Widget build(BuildContext context) {
    return GetMaterialApp(
      builder: (context, child) {
        return MediaQuery(
          data: MediaQuery.of(context).copyWith(textScaleFactor: 1),
          child: child!,
        );
      },
      debugShowCheckedModeBanner: false,
      title: 'Flutter Demo',
      theme: ThemeData(
        useMaterial3: true,
      ),
      home: SplashPage(),
      getPages: AppPages.pages,
      // getPages: [
      //   GetPage(name: PrivateChange.id, page: ()=>PrivateChange()),
      // ],
    );
  }
}

class SplashPage extends StatefulWidget {
  const SplashPage({Key? key}) : super(key: key);

  @override
  State<SplashPage> createState() => _SplashPageState();
}

class _SplashPageState extends State<SplashPage> {
  @override
  Widget build(BuildContext context) {
    return AnimatedSplashScreen(
      splashIconSize: double.maxFinite,
      // pageTransitionType: PageTransitionType.rightToLeft,
      splash: Container(
        height: Get.height,
        child: Center(
          child: Column(
            mainAxisAlignment: MainAxisAlignment.center,
            crossAxisAlignment: CrossAxisAlignment.center,
            children: [
              SvgPicture.asset('assets/icon/logo.svg'),
            ],
          ),
        ),
      ),
      nextScreen: LoginName(),
    );
  }
}
