import 'package:flutter/material.dart';
import 'package:get/get.dart';

import '../screen/util/font/font.dart';

showConfirmTapDialog(BuildContext context, String title,VoidCallback onTap) {
  showDialog(
      context: context,
      barrierDismissible: true,
      builder: (BuildContext context) {
        return AlertDialog(
          backgroundColor: Colors.white,
          shape: RoundedRectangleBorder(
            borderRadius: BorderRadius.circular(14),
          ),
          contentPadding: const EdgeInsets.only(top: 35, bottom: 35),
          content: Container(
            width: Get.width,
            padding: const EdgeInsets.symmetric(horizontal: 20),
            child: Text(
              '${title}',
              style: f16w700Size(),
              textAlign: TextAlign.center,
            ),
          ),
          actions: [
            Row(
              children: [
                Expanded(
                  child: GestureDetector(
                    onTap: () {
                      Get.back();
                    },
                    behavior: HitTestBehavior.opaque,
                    child: Center(
                      child: Container(
                        width: Get.width,
                        height: 42,
                        decoration: BoxDecoration(color: Color(0xffD3D8DE), borderRadius: BorderRadius.circular(8)),
                        child: Center(
                            child: Text(
                              '취소',
                              style: f16w700Size(),
                            )),
                      ),
                    ),
                  ),
                ),
                SizedBox(width: 8,),
                Expanded(
                  child: GestureDetector(
                    onTap: onTap,
                    behavior: HitTestBehavior.opaque,
                    child: Center(
                      child: Container(
                        width: Get.width,
                        height: 42,
                        decoration: BoxDecoration(color: Color(0xff1955EE), borderRadius: BorderRadius.circular(8)),
                        child: Center(
                            child: Text(
                              '확인',
                              style: f16w700WhiteSize(),
                            )),
                      ),
                    ),
                  ),
                ),
              ],
            )
          ],
        );
      });
}



showOnlyConfirmDialog(BuildContext context, String title) {
  showDialog(
      context: context,
      builder: (BuildContext context) {
        return AlertDialog(
          backgroundColor: Colors.white,
          shape: RoundedRectangleBorder(
            borderRadius: BorderRadius.circular(14),
          ),
          contentPadding: const EdgeInsets.only(top: 35, bottom: 35),
          content: Container(
            width: Get.width,
            padding: const EdgeInsets.symmetric(horizontal: 20),
            child: Text(
              '${title}',
              style: f16w700Size(),
              textAlign: TextAlign.center,
            ),
          ),
          actions: [
            Row(
              children: [
                Expanded(
                  child: GestureDetector(
                    onTap: () {
                      Get.back();
                    },
                    behavior: HitTestBehavior.opaque,
                    child: Center(
                      child: Container(
                        width: Get.width,
                        height: 42,
                        decoration: BoxDecoration(color: Color(0xff1955EE), borderRadius: BorderRadius.circular(8)),
                        child: Center(
                            child: Text(
                              '확인',
                              style: f16w700WhiteSize(),
                            )),
                      ),
                    ),
                  ),
                ),
              ],
            )
          ],
        );
      });
}


showOnlyConfirmTapDialog(BuildContext context, String title,VoidCallback ontap) {
  showDialog(
      context: context,
      barrierDismissible: false,
      builder: (BuildContext context) {
        return AlertDialog(
          backgroundColor: Colors.white,
          shape: RoundedRectangleBorder(
            borderRadius: BorderRadius.circular(14),
          ),
          contentPadding: const EdgeInsets.only(top: 35, bottom: 35),
          content: Container(
            width: Get.width,
            padding: const EdgeInsets.symmetric(horizontal: 20),
            child: Text(
              '${title}',
              style: f16w700Size(),
              textAlign: TextAlign.center,
            ),
          ),
          actions: [
            Row(
              children: [
                Expanded(
                  child: GestureDetector(
                    onTap: ontap,
                    behavior: HitTestBehavior.opaque,
                    child: Center(
                      child: Container(
                        width: Get.width,
                        height: 42,
                        decoration: BoxDecoration(color: Color(0xff1955EE), borderRadius: BorderRadius.circular(8)),
                        child: Center(
                            child: Text(
                              '확인',
                              style: f16w700WhiteSize(),
                            )),
                      ),
                    ),
                  ),
                ),
              ],
            )
          ],
        );
      });
}


// showAlertOffDialog(BuildContext context, String title,VoidCallback ontap) {
//   showDialog(
//       context: context,
//       builder: (BuildContext context) {
//         return AlertDialog(
//           backgroundColor: Colors.white,
//           shape: RoundedRectangleBorder(
//             borderRadius: BorderRadius.circular(14),
//           ),
//           contentPadding: const EdgeInsets.only(top: 35, bottom: 35),
//           content: Container(
//             width: Get.width,
//             padding: const EdgeInsets.symmetric(horizontal: 20),
//             child: Text(
//               '${title}',
//               style: f16w700Size(),
//               textAlign: TextAlign.center,
//             ),
//           ),
//           actions: [
//             Row(
//               children: [
//                 Expanded(
//                   child: GestureDetector(
//                     onTap: ontap,
//                     behavior: HitTestBehavior.opaque,
//                     child: Center(
//                       child: Container(
//                         width: Get.width,
//                         height: 42,
//                         decoration: BoxDecoration(color: Color(0xff1955EE), borderRadius: BorderRadius.circular(8)),
//                         child: Center(
//                             child: Text(
//                               '확인',
//                               style: f16w700WhiteSize(),
//                             )),
//                       ),
//                     ),
//                   ),
//                 ),
//               ],
//             )
//           ],
//         );
//       });
// }