import 'package:flutter/material.dart';

import '../screen/util/color.dart';
import '../screen/util/font/font.dart';

class SwitchButton extends StatefulWidget {
  final bool value;
  final VoidCallback onTap;

  const SwitchButton({Key? key, required this.onTap, required this.value})
      : super(key: key);

  @override
  _SwitchButtonState createState() => _SwitchButtonState();
}

class _SwitchButtonState extends State<SwitchButton> {
  final animationDuration = Duration(milliseconds: 300);

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
      onTap: widget.onTap,
      child: Stack(
        children: [
          AnimatedContainer(
            height: 35,
            width: 68,
            // Increased width to accommodate the text
            duration: animationDuration,
            decoration: BoxDecoration(
              borderRadius: BorderRadius.circular(30),
              color: widget.value ? blueColor : Color(0xffE7E7E7),
            ),
            child: AnimatedAlign(
              duration: animationDuration,
              alignment:
                  widget.value ? Alignment.centerRight : Alignment.centerLeft,
              child: Padding(
                padding: const EdgeInsets.symmetric(horizontal: 4, vertical: 4),
                child: Stack(
                  alignment: Alignment.center,
                  children: [
                    Material(
                      elevation: 2,
                      borderRadius: BorderRadius.circular(100),
                      child: Container(
                        width: 28,
                        height: 28,
                        decoration: BoxDecoration(
                          shape: BoxShape.circle,
                          color: Colors.white,
                        ),
                      ),
                    ),
                  ],
                ),
              ),
            ),
          ),
          widget.value
              ? Positioned(left: 10,top: 10, child: Text('ON',style: f12Whitew700,))
              : Positioned(right: 6,top: 10, child: Text('OFF',style: f12Whitew700,))
        ],
      ),
    );
  }
}
