import 'dart:convert';

import 'package:get/get.dart';
import 'package:http/http.dart' as http;
import '../provider/user_state.dart';

/// 모니터링 정보 가져오기
Future<void> MonitoringInfo() async{
  final us= Get.put(UserState());
  final url = 'http://misnetwork.iptime.org:9000/monitoInfo?id=${us.userList[0]['mms']}';
  final response = await http.get(Uri.parse(url));
  Map<String, dynamic> dataList = json.decode(response.body);
  us.userMonitoring.value = [dataList];
  if (response.statusCode != 200) {
    print('에러에러');
    throw Exception('Failed to send email');
  }
}
/// 소켓에 정보 보내기
Future<void> getInfo() async {
  final us = Get.put(UserState());
  /// 소방수신기 알림
  List alimCheck = [];
  alimCheck = List.generate(5, (index) => false);
  List<int> dataToSend =[];

  ///주경종이 true 일떄
  if(bool.parse('${us.userMonitoring[0]['mainjong']}')){
    alimCheck[1] = true;
  }
  /// 지구경종이 true 일때
  if(bool.parse('${us.userMonitoring[0]['subjong']}')){
    alimCheck[2] = true;
  }
  /// 부저가 true 일때
  if(bool.parse('${us.userMonitoring[0]['buzzer']}')){
    alimCheck[3] = true;
  }
  /// 사이렌이 true 일때
  if(bool.parse('${us.userMonitoring[0]['siren']}')){
    alimCheck[4] = true;
  }

  String switchString = alimCheck.map((flag) => flag?'1':'0').join();
  String reversedString = switchString.substring(1).split('').reversed.join();
  int decimalValue = int.parse(reversedString, radix: 2);
  String hexvalue = '0x${decimalValue.toRadixString(16).padLeft(2, '0')}';
  String switchValue = '';
  print('userdata ${us.userMonitoring[0]['data']}');
  /// 메인쪽 스위치
  if(bool.parse('${us.userMonitoring[0]['data']}')){
    switchValue = '0x1a';
  }
  else{
    switchValue = '0x2a';
  }
  dataToSend = [
    0xc0, // Start
    0x0d, // Len
    0x10, // Packet Type
    0x05, 0x01, 0x00, 0x23, 0x05, int.parse('${hexvalue}'),int.parse('${switchValue}'), 0xb0, 0x00, 0x00, 0x1e, //Payload
    0xa8 // XOR
  ];

  us.userSocketData.value = dataToSend;
  us.update();
}

/// 소켓 스위치 함수 flutter -> server -> db -> mms
Future<void> changeSwitch(bool stw,String field) async {
  final us = Get.put(UserState());
  /// 소방수신기 알림
  List<int> dataToSend =[];
  String switchValue = '';
  String packType = ''; /// 패킷타입
  switch (field) {
    case '급수관':
      packType = '0x97';
      if(stw){
        switchValue = '0x01';
      }
      else{
        switchValue = '0x00';
      }
      break;
    case '알림발송':
      packType = '0x90';
      if(stw){
        switchValue = '0x01';
      }
      else{
        switchValue = '0x00';
      }
      break;
    case '주경종':
      packType = '0x91';
      if(stw){
        switchValue = '0x01';
      }
      else{
        switchValue = '0x00';
      }
      break;
    case '지구경종':
      packType = '0x92';
      if(stw){
        switchValue = '0x01';
      }
      else{
        switchValue = '0x00';
      }
      break;
    case '부저':
      packType = '0x93';
      if(stw){
        switchValue = '0x01';
      }
      else{
        switchValue = '0x00';
      }
      break;
    case '사이렌':
      packType = '0x94';
      if(stw){
        switchValue = '0x01';
      }
      else{
        switchValue = '0x00';
      }
      break;
  }
  dataToSend = [
    0xc0, // Start
    0x03, // Len
    int.parse('${packType}'), // Packet Type
    int.parse('${switchValue}'), //Payload
    0xa8 // XOR
  ];

  us.userSocketData.value = dataToSend;
  us.update();
}