import 'package:flutter/material.dart';
import 'package:flutter_svg/flutter_svg.dart';
import 'package:get/get.dart';

import '../../bottom_navigator.dart';
import '../../components/color_radio.dart';
import '../../components/dialog.dart';
import '../../provider/notification_state.dart';
import '../../screen/monitoring/fire/firesettingTest.dart';
import '../../screen/util/font/font.dart';
import 'alert_turn_off.dart';

class AlertFireReceiver extends StatefulWidget {
  const AlertFireReceiver({Key? key}) : super(key: key);

  @override
  State<AlertFireReceiver> createState() => _AlertFireReceiverState();
}

class _AlertFireReceiverState extends State<AlertFireReceiver> {
  bool switchButton = false;
  final ns = Get.put(NotificationState());
  // int _type = 0;

  @override
  void initState() {

    super.initState();
  }


  @override
  Widget build(BuildContext context) {
    return Scaffold(
        appBar: AppBar(
          title: Text('알림발생',style: f16w900Size(),),
          centerTitle: true,
          shape: Border(
            bottom: BorderSide(
              color:  const Color(0xffEFF0F0),
              width: 1,
            ),
          ),
          leading: GestureDetector(
              onTap: (){
                showConfirmTapDialog(context, '메인 화면으로 이동하시겠습니까?', () {
                  Get.offAll(BottomNavigator());
                });
              },
              child: Icon(Icons.arrow_back_ios)),
        ),
        backgroundColor: const Color(0xffF1F4F7),
        body: Padding(
          padding: const EdgeInsets.symmetric(vertical: 10,horizontal: 10),
          child: SingleChildScrollView(
            physics: const ClampingScrollPhysics(),
            child: Column(
              children: [
                Container(
                  padding: const EdgeInsets.symmetric(vertical: 20),
                  width: Get.width,
                  decoration: BoxDecoration(
                      borderRadius: BorderRadius.circular(20),
                      color: Colors.white
                  ),
                  child: Column(
                    crossAxisAlignment: CrossAxisAlignment.center,
                    children: [
                      SvgPicture.asset('assets/icon/alert.svg',width: 80,height: 80,),
                      const SizedBox(height: 8,),
                      Text('소방수신기 경보',style: f21wRed700Size(),),
                      const SizedBox(height: 8,),
                      Text('천안 A아파트에\n소방화재 경보 발생!\n긴급 점검 바랍니다',style: f18w500Size(),textAlign: TextAlign.center,)
                    ],
                  ),
                ),
                const SizedBox(height: 10,),
                GestureDetector(
                  behavior: HitTestBehavior.opaque,
                  onTap: () {
                    // socket.destroy();
                    Get.to(() => FireSetting2Screen())!.then((value) {
                      // Future.delayed(Duration.zero,()async{
                      //   await MonitoringInfo().then((value) async{
                      //     socket = await Socket.connect('220.89.248.140', 5161);
                      //     await getInfo(); ///소캣 정보 가져오기
                      //     socket.add(us.userSocketData.value);
                      //     // int decimalNumber = 30;
                      //     // String hexadecimalNumber = decimalToHex(decimalNumber);
                      //     // String hexString = '0x$hexadecimalNumber';
                      //     //
                      //     // ///주경종이 true 일떄
                      //     // if(bool.parse('${us.userMonitoring[0]['mainjong']}')){
                      //     //   alimCheck[1] = true;
                      //     // }
                      //     // /// 지구경종이 true 일때
                      //     // if(bool.parse('${us.userMonitoring[0]['subjong']}')){
                      //     //   alimCheck[2] = true;
                      //     // }
                      //     // /// 부저가 true 일때
                      //     // if(bool.parse('${us.userMonitoring[0]['buzzer']}')){
                      //     //   alimCheck[3] = true;
                      //     // }
                      //     // /// 사이렌이 true 일때
                      //     // if(bool.parse('${us.userMonitoring[0]['siren']}')){
                      //     //   alimCheck[4] = true;
                      //     // }
                      //     //
                      //     // String switchString = alimCheck.map((flag) => flag?'1':'0').join();
                      //     // String reversedString = switchString.substring(1).split('').reversed.join();
                      //     // print('??리버스 스위치 ${reversedString}');
                      //     // int decimalValue = int.parse(reversedString, radix: 2);
                      //     // String hexvalue = '0x${decimalValue.toRadixString(16).padLeft(2, '0')}';
                      //     //
                      //     // /// 급수관 개폐 true
                      //     // // if(bool.parse('${us.userMonitoring[0]['data']}')){
                      //     // //   dataToSend = [
                      //     // //     0xc0, // Start
                      //     // //     0x0d, // Len
                      //     // //     0x10, // Packet Type
                      //     // //     0x05, 0x01, 0x00, 0x23, 0x05, int.parse('${hexvalue}'), 0x1a, 0xb0, 0x00, 0x00, int.parse('${hexString}'), //Payload
                      //     // //     0xa8 // XOR
                      //     // //   ];
                      //     // // }
                      //     // // else{
                      //     // //   dataToSend = [
                      //     // //     0xc0, // Start
                      //     // //     0x0d, // Len
                      //     // //     0x10, // Packet Type
                      //     // //     0x05, 0x01, 0x00, 0x23, 0x05, int.parse('${hexvalue}'), 0x2a, 0xb0, 0x00, 0x00, int.parse('${hexString}'), //Payload
                      //     // //     0xa8 // XOR
                      //     // //   ];
                      //     // // }
                      //     // // socket.add(dataToSend);
                      //     _isLoading = false;
                      //     setState(() {});
                      //   });
                      //
                      // });
                    });
                  },
                  child: Container(
                    width: Get.width,
                    height: 75,
                    decoration: BoxDecoration(color: Colors.white, borderRadius: BorderRadius.circular(20)),
                    child: Padding(
                      padding: const EdgeInsets.only(left: 20, right: 18),
                      child: Row(
                        mainAxisAlignment: MainAxisAlignment.start,
                        children: [
                          Text(
                            '소방수신기 상태',
                            style: f18w700Size(),
                          ),
                          Spacer(),
                          BlueRadio(),
                          const SizedBox(
                            width: 6,
                          ),
                          Text(
                            '정상',
                            style: bluef18w700(),
                          ),
                          const SizedBox(
                            width: 14,
                          ),
                          SvgPicture.asset('assets/icon/rightArrow.svg')
                        ],
                      ),
                    ),
                  ),
                ),
              ],
            ),
          ),
        ),
        bottomNavigationBar: GestureDetector(
          onTap: ()async{
            ns.alertTurnOffList.value = ['소방수신기 오작동','소방서 신고','화재 원인 해결','테스트 및 시험','기타 (직접입력)'];
            Get.to(() => AlertTurnOff());
          },
          child: Container(
            width: Get.width,
            height: 60,
            color:   const Color(0xffE83B3B),
            padding: const EdgeInsets.symmetric(vertical: 16),
            child: Center(child: Text('알림해제',style: f18w700WhiteSize(),)),
          ),
        )
    );
  }
}
