import 'package:flutter/material.dart';
import 'package:flutter_svg/flutter_svg.dart';
import 'package:get/get.dart';

import '../../components/color_radio.dart';
import '../../provider/notification_state.dart';
import '../../screen/util/font/font.dart';
import 'alert_turn_off.dart';

class AlertTransFormer extends StatefulWidget {
  const AlertTransFormer({Key? key}) : super(key: key);

  @override
  State<AlertTransFormer> createState() => _AlertTransFormerState();
}

class _AlertTransFormerState extends State<AlertTransFormer> {
  bool switchButton = false;
  final ns = Get.put(NotificationState());
  // int _type = 0;

  @override
  void initState() {

    super.initState();
  }


  @override
  Widget build(BuildContext context) {
    return Scaffold(
        appBar: AppBar(
          title: Text('알림발생',style: f16w900Size(),),
          centerTitle: true,
          shape: Border(
            bottom: BorderSide(
              color:  const Color(0xffEFF0F0),
              width: 1,
            ),
          ),
        ),
        backgroundColor: const Color(0xffF1F4F7),
        body: Padding(
          padding: const EdgeInsets.symmetric(vertical: 10,horizontal: 10),
          child: SingleChildScrollView(
            physics: const ClampingScrollPhysics(),
            child: Column(
              children: [
                Container(
                  padding: const EdgeInsets.symmetric(vertical: 20),
                  width: Get.width,
                  decoration: BoxDecoration(
                      borderRadius: BorderRadius.circular(20),
                      color: Colors.white
                  ),
                  child: Column(
                    children: [
                      SvgPicture.asset('assets/icon/alert.svg',width: 80,height: 80,),
                      const SizedBox(height: 8,),
                      Text('온도 상승 경보',style: f21wRed700Size(),),
                      const SizedBox(height: 8,),
                    ],
                  ),
                ),
                const SizedBox(height: 10,),
                Container(
                  width: Get.width,
                  child: Row(
                    mainAxisAlignment: MainAxisAlignment.center,
                    children: [
                      Spacer(),
                      Container(
                        child: Column(
                          crossAxisAlignment: CrossAxisAlignment.center,
                          children: [
                            Text(
                              '변압기 온도',
                              style: grf14w600(),
                            ),
                            Row(
                              children: [
                                Text(
                                  '45',
                                  style: f28w700Size(),
                                ),
                                const SizedBox(
                                  width: 4,
                                ),
                                Text(
                                  '°C',
                                  style: f18w400Size(),
                                )
                              ],
                            )
                          ],
                        ),
                      ),
                      Spacer(),
                      Container(
                        height: 38,
                        child: VerticalDivider(
                          color: Color(0xffC5C9CC),
                          thickness: 1,
                        ),
                      ),
                      Spacer(),
                      Container(
                        child: Column(
                          children: [
                            Text(
                              '변압기 온도',
                              style: grf14w600(),
                            ),
                            Row(
                              children: [
                                Text(
                                  '25',
                                  style: f28w700Size(),
                                ),
                                const SizedBox(
                                  width: 4,
                                ),
                                Text(
                                  '°C',
                                  style: f18w400Size(),
                                )
                              ],
                            )
                          ],
                        ),
                      ),
                      Spacer(),
                    ],
                  ),
                ),
              ],
            ),
          ),
        ),
        bottomNavigationBar: GestureDetector(
          onTap: ()async{
            ns.alertTurnOffList.value = ['온도센서 오작동','사고 인지 및 해결 중','정상 복구 완료','테스트 및 시험','기타 (직접입력)'];
            Get.to(() => AlertTurnOff());
          },
          child: Container(
            width: Get.width,
            height: 60,
            color:   const Color(0xffE83B3B),
            padding: const EdgeInsets.symmetric(vertical: 16),
            child: Center(child: Text('알림해제',style: f18w700WhiteSize(),)),
          ),
        )
    );
  }
}
