import 'package:flutter/material.dart';
import 'package:flutter_svg/flutter_svg.dart';
import 'package:get/get.dart';

import '../../provider/notification_state.dart';
import '../../screen/util/font/font.dart';
import 'alert_turn_off.dart';

class AlertWaterTank extends StatefulWidget {
  const AlertWaterTank({Key? key}) : super(key: key);

  @override
  State<AlertWaterTank> createState() => _AlertWaterTankState();
}

class _AlertWaterTankState extends State<AlertWaterTank> {
  bool switchButton = false;
  final ns = Get.put(NotificationState());
  // int _type = 0;
  List _alertTitle = ['저수조 고수위 경보','저수조 저수위 경보'];

  @override
  void initState() {

    super.initState();
  }


  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text('알림발생',style: f16w900Size(),),
        centerTitle: true,
        shape: Border(
          bottom: BorderSide(
            color:  const Color(0xffEFF0F0),
            width: 1,
          ),
        ),
      ),
      backgroundColor: const Color(0xffF1F4F7),
      body: Padding(
        padding: const EdgeInsets.symmetric(vertical: 10,horizontal: 10),
        child: SingleChildScrollView(
          physics: const ClampingScrollPhysics(),
          child: Column(
            children: [
              Container(
                padding: const EdgeInsets.symmetric(vertical: 20),
                width: Get.width,
                decoration: BoxDecoration(
                  borderRadius: BorderRadius.circular(20),
                  color: Colors.white
                ),
                child: Column(
                  children: [
                    SvgPicture.asset('assets/icon/alert.svg',width: 80,height: 80,),
                    const SizedBox(height: 8,),

                    /// 0이면 고수위 1이면 저수위 default 0
                    Text('${_alertTitle[ns.lowHighType.value]}',style: f21wRed700Size(),),
                    const SizedBox(height: 8,),
                    Text('수위 : 90%',style: f18w500Size(),)
                  ],
                ),
              ),
              const SizedBox(height: 10,),
              Container(
                  padding: const EdgeInsets.symmetric(horizontal: 20, vertical: 20),
                  decoration: BoxDecoration(borderRadius: BorderRadius.circular(20), color: Colors.white),
                  width: Get.width,
                  // height: 162,
                  child: Column(
                    crossAxisAlignment: CrossAxisAlignment.start,
                    mainAxisAlignment: MainAxisAlignment.center,
                    children: [
                      Text(
                        '급수밸브',
                        style: f14w600Size(),
                      ),
                      SizedBox(height: 10),
                      Row(
                        mainAxisAlignment: MainAxisAlignment.spaceBetween,
                        children: [
                          GestureDetector(
                              onTap:(){
                                switchButton = true;
                                setState(() {

                                });
                              },
                              child: Text('열기', style: switchButton ? f16w700Size() : f16w600GreySize(),)),
                          switchButton ? SvgPicture.asset(
                            'assets/icon/valve_open.svg',
                            width: 140,
                            height: 48,
                          ) :  SvgPicture.asset(
                            'assets/icon/valve_closed.svg',
                            width: 140,
                            height: 48,
                          ),
                          GestureDetector(
                              onTap:(){
                                switchButton = false;
                                setState(() {

                                });
                              },
                              child: Text('닫기', style: !switchButton ? f16w700Size() : f16w600GreySize(),)),
                        ],
                      ),
                    ],
                  )),
            ],
          ),
        ),
      ),
        bottomNavigationBar: GestureDetector(
          onTap: ()async{
            ns.alertTurnOffList.value = ['수위센서 오작동','사고 인지 및 해결 중','정상 복구 완료','테스트 및 시험','기타 (직접입력)'];
            Get.to(() => AlertTurnOff());
          },
          child: Container(
            width: Get.width,
            height: 60,
            color:   const Color(0xffE83B3B),
            padding: const EdgeInsets.symmetric(vertical: 16),
            child: Center(child: Text('알림해제',style: f18w700WhiteSize(),)),
          ),
        )
    );
  }
}
