import 'dart:async';
import 'dart:convert';
import 'dart:typed_data';
import 'package:firebase_core/firebase_core.dart';
import 'package:firebase_messaging/firebase_messaging.dart';
import 'package:flutter_local_notifications/flutter_local_notifications.dart';



Future<void> onBackgroundMessage(RemoteMessage message) async {
  await Firebase.initializeApp();

  if (message.data.containsKey('data')) {
    final data = message.data['data'];
  }

  if (message.data.containsKey('notification')) {
    final notification = message.data['notification'];
  }
}

class FCM {
  final _firebaseMessaging = FirebaseMessaging.instance;
  var flutterLocalNotificationsPlugin = FlutterLocalNotificationsPlugin();
  final streamCtlr = StreamController<String>.broadcast();
  final titleCtlr = StreamController<String>.broadcast();
  final bodyCtlr = StreamController<String>.broadcast();

  var channel = const AndroidNotificationChannel(
    'sSolution', 'sSolution2',
    description: 'this is fcm channel', // description
    importance: Importance.high,

  );

  setNotifications() {
    FirebaseMessaging.onBackgroundMessage(onBackgroundMessage);

    foregroundNotification();

    backgroundNotification();
    //
    terminateNotification();
    // final token =// _firebaseMessaging.getToken().then((value) => print('Token: $value'));
  }
  ///버튼 눌렀을 때 포그라운드
  foregroundNotification() {
    final Int64List vibrationPattern = Int64List(5);
    vibrationPattern[0] = 0;      // 진동 시작 전 대기 시간 (0초)
    vibrationPattern[1] = 2000;   // 첫 번째 진동 시간 (1초)
    vibrationPattern[2] = 2000;   // 진동과 진동 사이 대기 시간 (1초)
    vibrationPattern[3] = 3000;   // 두 번째 진동 시간 (2초)
    vibrationPattern[4] = 4000;   // 두 번째 진동 시간 (2초)

    const String darwinNotificationCategoryPlain = 'plainCategory';

    DarwinNotificationCategory(
      darwinNotificationCategoryPlain,
      actions: <DarwinNotificationAction>[
        DarwinNotificationAction.plain('id_1', 'Action 1'),
        DarwinNotificationAction.plain(
          'id_2',
          'Action 2 (destructive)',
          options: <DarwinNotificationActionOption>{
            DarwinNotificationActionOption.destructive,
          },
        ),
        DarwinNotificationAction.plain(
          'id',
          'Action 3 (foreground)',
          options: <DarwinNotificationActionOption>{
            DarwinNotificationActionOption.foreground,
          },
        ),
        DarwinNotificationAction.plain(
          'id_4',
          'Action 4 (auth required)',
          options: <DarwinNotificationActionOption>{
            DarwinNotificationActionOption.authenticationRequired,
          },
        ),
      ],

      options: <DarwinNotificationCategoryOption>{
        DarwinNotificationCategoryOption.hiddenPreviewShowTitle,
      },
    );

    ///IOS 알림
    const DarwinNotificationDetails iosNotificationDetails = DarwinNotificationDetails(
      categoryIdentifier: darwinNotificationCategoryPlain,
      presentBadge: true,
      presentAlert: true,
      presentSound: true,
      sound: 'default',
      threadIdentifier: 'plainCategory',
    );

    FirebaseMessaging.onMessage.listen((RemoteMessage message) async {
      print('포그라운드 들어옴');
      flutterLocalNotificationsPlugin.show(
          message.hashCode,
          message.notification?.title,
          message.notification?.body,
          NotificationDetails(
              android: AndroidNotificationDetails(
                channel.id,
                channel.name,
                channelDescription: channel.description,
                icon: '@mipmap/ic_launcher',
                vibrationPattern: vibrationPattern,

                ),
              iOS: iosNotificationDetails,
          ),
          payload: '${message?.data}');

    });
  }

  backgroundNotification() async {
    final Int64List vibrationPattern = Int64List(4);
    vibrationPattern[0] = 0;      // 진동 시작 전 대기 시간 (0초)
    vibrationPattern[1] = 1000;   // 첫 번째 진동 시간 (1초)
    vibrationPattern[2] = 1000;   // 진동과 진동 사이 대기 시간 (1초)
    vibrationPattern[3] = 2000;   // 두 번째 진동 시간 (2초)
    vibrationPattern[3] = 2000;   // 두 번째 진동 시간 (2초)

    const DarwinNotificationDetails iosNotificationDetails = DarwinNotificationDetails(
      presentBadge: true,
      presentAlert: true,
      presentSound: true,
      sound: 'default',
    );
    FirebaseMessaging.onMessageOpenedApp.listen(
          (message) async {
            print('?? dasda ${message.data}');
        Map<String, dynamic> dataMap = json.decode('${message.data}');
        print('ㄴㄹㅁㄴㅁㅁㅁㅁ : ${message.notification!.title!}');
        print('ㄴㄹㅁㄴㅁㅁㅁㅁ22 : ${message.notification!.body!}');
        print('ㄴㄹㅁㄴㅁㅁㅁㅁ33 : ${dataMap['name']}');

        // up.fcmDocId = '${message.data['docId']}';
        titleCtlr.sink.add(message.notification!.title!);
        bodyCtlr.sink.add(message.notification!.body!);
            flutterLocalNotificationsPlugin.show(
                message.hashCode,
                message.notification?.title,
                message.notification?.body,
                NotificationDetails(
                  android: AndroidNotificationDetails(
                    channel.id,
                    channel.name,
                    channelDescription: channel.description,
                    icon: '@mipmap/ic_launcher',
                    vibrationPattern: vibrationPattern,

                  ),
                  iOS: iosNotificationDetails,
                ),
                payload: '${message?.data}');
      },
    );
  }
  //
  terminateNotification() async {
    RemoteMessage? initialMessage = await FirebaseMessaging.instance.getInitialMessage();

    if (initialMessage != null) {

      print('ㅋㅋㅋㅋㅋ : ${initialMessage.notification!.title!}');
      print('ㅋㅋㅋㅋㅋㅋ22 : ${initialMessage.notification!.body!}');
      print('ㅋㅋㅋㅋㅋㅋ33 : ${initialMessage.data['name']}');

      titleCtlr.sink.add(initialMessage.notification!.title!);
      bodyCtlr.sink.add(initialMessage.notification!.body!);
    }
  }
  dispose() {
    streamCtlr.close();
    bodyCtlr.close();
    titleCtlr.close();
  }
}

// class FCMController {
//   final String _serverKey =
//       "AAAA6RlPOZ0:APA91bHl4TNWSQH8O9s83Qbof11BZgLGrBH3AdM0zZiM4C_152I19xwVS_V8pDQ3aJmw3s88V07pGf9sHy41NsGtuFtJqqkB6rrGPjDlXjHG4U_y3fjfQFqacWW4ppIrVJPbjASu38mp";
//
//   Future<void> sendMessage({
//     required String userToken,
//     required String title,
//     required String body,
//   }) async {
//     http.Response response;
//
//     NotificationSettings settings = await FirebaseMessaging.instance.requestPermission(
//       alert: true,
//       announcement: false,
//       badge: true,
//       carPlay: false,
//       criticalAlert: false,
//       provisional: false,
//       sound: true,
//     );
//
//     if (settings.authorizationStatus == AuthorizationStatus.authorized) {
//       print('User granted permission');
//     } else if (settings.authorizationStatus == AuthorizationStatus.provisional) {
//       print('User granted provisional permission');
//     } else {
//       print('User declined or has not accepted permission');
//     }
//
//     try {
//       response = await http.post(Uri.parse('https://fcm.googleapis.com/fcm/send'),
//           headers: <String, String>{'Content-Type': 'application/json', 'Authorization': 'key=$_serverKey'},
//           body: jsonEncode({
//             'notification': {'title': title, 'body': body, 'sound': 'true'},
//             'ttl': '60s',
//             "content_available": true,
//             'data': {
//               'click_action': 'FLUTTER_NOTIFICATION_CLICK',
//               'id': '1',
//               'status': 'done',
//               "action": 'clickSound',
//             },
//             // 'topic': 'community',
//             // 상대방 토큰 값, to -> 단일, registration_ids -> 여러명
//             'to': userToken
//             // 'registration_ids': tokenList
//           }));
//     } catch (e) {
//       print('error $e');
//     }
//   }
// }