import 'package:flutter/material.dart';
import 'package:get/get.dart';
import 'package:vsdk/camera_device/camera_device.dart';
import 'package:vsdk_example/ssolution/lib/screen/util/loading.dart';
import 'package:vsdk_example/utils/super_put_controller.dart';

import '../../../../app_routes.dart';
import '../../../../main/main_logic.dart';
import '../util/font/font.dart';

class CameraMain extends StatefulWidget {
  const CameraMain({Key? key}) : super(key: key);

  @override
  State<CameraMain> createState() => _CameraMainState();
}

class _CameraMainState extends State<CameraMain> {
  // final state = controller.state;
  bool _isLoading = true;

  @override
  void initState() {
    Get.put(MainLogic());
    Future.delayed(Duration.zero,()async {

     await Get.tryFind<MainLogic>(tag: '').init('AAC0523246PCCM','cam1','1234567890');
     setState(() {
       _isLoading = false;
     });
      // if (CameraConnectState.connected) {
        print('연결 됐습니다--------');
      // }
    });
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        backgroundColor: Colors.white,
        automaticallyImplyLeading: false,
        title: Text('카메라 메인',style: f16w700Size(),),
      ),
      body: _isLoading ? LoadingScreen() :Padding(
        padding: const EdgeInsets.symmetric(horizontal: 10),
        child: Column(
          children: [
            GestureDetector(
              onTap: (){
                Get.toNamed(AppRoutes.play);
              },
              child: Container(
                decoration: BoxDecoration(
                  borderRadius: BorderRadius.circular(8),
                  border: Border.all(
                    color: Colors.black,
                    width: 2
                  )
                ),
                padding: const EdgeInsets.symmetric(vertical: 20),
                child: Center(
                  child: Image.asset('assets/icon/play_button.png',width: 80,height: 80,),
                ),
              ),
            ),
            // Center(
            //   child: _isLoading ? LoadingScreen() : GestureDetector(
            //     onTap: (){
            //       Get.toNamed(AppRoutes.play);
            //     },
            //     child: Text('현재 준비중입니다'),
            //   ),
            // ),
          ],
        ),
      )
    );
  }
}
