import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:get/get.dart';
import 'package:get/get_core/src/get_main.dart';
import 'package:http/http.dart' as http;
import '../../bottom_navigator.dart';
import '../../provider/user_state.dart';
import '../util/encryption.dart';
import '../util/font/font.dart';

class PwChange extends StatefulWidget {
  const PwChange({super.key});

  @override
  State<PwChange> createState() => _PwChangeState();
}

class _PwChangeState extends State<PwChange> {
  final FocusNode _pwFocusNode  = FocusNode();
  final FocusNode _pwCheckFocusNode = FocusNode();
  TextEditingController _pwCon = TextEditingController();
  bool _obscurePassword = true;
  bool _obscurePassword2 = true;
  @override
  Widget build(BuildContext context) {
    return GestureDetector(
      onTap: (){

        FocusScope.of(context).unfocus();
      },
      child: Scaffold(
        appBar: AppBar(
          automaticallyImplyLeading: false,
          backgroundColor: Colors.white,
          leading: IconButton(
              icon: Icon(Icons.arrow_back_ios),
              onPressed: () {
                Get.back();
              }
          ),
        ),
        body: Padding(
          padding: const EdgeInsets.symmetric(horizontal: 20),
          child: Column(
            mainAxisAlignment: MainAxisAlignment.start,
            crossAxisAlignment: CrossAxisAlignment.start,
            children: [
              Text('새로운\n비밀번호를\n입력해주세요',
              style: f28w800Size(),
              ),
              SizedBox(height: 56,),
              Text('비밀번호',
                style: f16w700Size(),),

              SizedBox(height: 8,),

              ///비밀번호 입력칸
              TextFormField(
                controller: _pwCon,
                onFieldSubmitted: (value) {
                  FocusScope.of(context).requestFocus(_pwCheckFocusNode);
                },
                obscuringCharacter: "*",
                focusNode: _pwFocusNode,
                inputFormatters: [
                  LengthLimitingTextInputFormatter(20)
                ],
                obscureText: _obscurePassword,
                onTap: () {
                  FocusScope.of(context).unfocus();
                },
                decoration: InputDecoration(
                  hintText: '비밀번호를 입력해주세요',
                  hintStyle: TextStyle(
                    fontSize: 12,
                    fontFamily: 'Pretendard',
                    fontWeight: FontWeight.w400,
                    color: Color(0xffB5B5B5),
                  ),
                  contentPadding: EdgeInsets.fromLTRB(15, 18, 0, 18),
                  filled: true,
                  fillColor: Color(0xFFF5F6F7),
                  enabledBorder: UnderlineInputBorder(
                    borderSide: BorderSide.none,
                  ),
                  focusedBorder: UnderlineInputBorder(
                    borderSide: BorderSide.none,
                  ),
                  suffixIcon: GestureDetector(
                    onTap: () {
                      setState(() {
                        _obscurePassword = !_obscurePassword;
                      });
                    },
                    child: Icon(
                      _obscurePassword ? Icons.visibility_off : Icons.visibility,
                      color: Color(0xff999FAF),
                    ),
                  ),
                ),
              ),

              SizedBox(height: 30,),

              Text('비밀번호 (확인)', style: f16w700Size(),),
              SizedBox(height: 8,),
              ///비밀번호(확인) 입력칸
              TextFormField(
                onFieldSubmitted: (value) {
                  _pwCheckFocusNode.unfocus();
                },
                focusNode: _pwCheckFocusNode,
                obscuringCharacter: "*",
                inputFormatters: [
                  LengthLimitingTextInputFormatter(20)
                ],
                obscureText: _obscurePassword2,
                onTap: () {
                  FocusScope.of(context).unfocus();
                },
                decoration: InputDecoration(
                  hintText: '비밀번호를 입력해주세요',
                  hintStyle: TextStyle(
                    fontSize: 12,
                    fontFamily: 'Pretendard',
                    fontWeight: FontWeight.w400,
                    color: Color(0xffB5B5B5),
                  ),
                  contentPadding: EdgeInsets.fromLTRB(15, 18, 0, 18),
                  filled: true,
                  fillColor: Color(0xFFF5F6F7),
                  enabledBorder: UnderlineInputBorder(
                    borderSide: BorderSide.none,
                  ),
                  focusedBorder: UnderlineInputBorder(
                    borderSide: BorderSide.none,
                  ),
                  suffixIcon: GestureDetector(
                    onTap: () {
                      setState(() {
                        _obscurePassword2 = !_obscurePassword2;
                      });
                    },
                    child: Icon(
                      _obscurePassword2 ? Icons.visibility_off : Icons.visibility,
                      color: Color(0xff999FAF),
                    ),
                  ),
                ),
              ),
            ],
          ),
        ),
        bottomNavigationBar: GestureDetector(
          onTap: ()async{
            await changePw(_pwCon.text);
            Get.to(()=> BottomNavigator());
          },
          child: Container(
            width: double.infinity,
            height: 60,
            decoration: BoxDecoration(
              color: Color(0xff1955EE),
            ),
            child: Center(
              child: Text('메인화면으로 이동',
                style: TextStyle(
                    fontFamily: 'Pretendard',
                    fontSize: 18,
                    fontWeight: FontWeight.w700,
                    color: Colors.white
                ),),
            ),
          ),
        ),
      ),
    );
  }
  /// 회원정보 가져오기
  Future<void> changePw(String pw) async{
    final us= Get.put(UserState());
    String newPw = textEncryption(pw, 1);
    final url = 'http://misnetwork.iptime.org:9000/changepw?id=${us.userList[0]['id']}&pw=${newPw}';
    final response = await http.get(Uri.parse(url));
    us.userList[0]['pw'] = newPw;
    if (response.statusCode != 200) {
      print('에러에러');
      throw Exception('Failed to send email');
    }
  }
}
