
import 'package:flutter/material.dart';
import 'package:flutter_svg/flutter_svg.dart';
import 'package:get/get.dart';
import 'package:get/get_core/src/get_main.dart';


import '../util/font/font.dart';
import 'pw_change_screen.dart';

class Terms extends StatefulWidget {
  const Terms({super.key});

  @override
  State<Terms> createState() => _TermsState();
}

class _TermsState extends State<Terms> {
  bool isChecked = false; /// 개인정보 수집 및 이용
  bool isChecked2 = false; /// 서비스 이용약관
  bool isChecked3 = false; /// 모두 동의합니다
  bool isExpanded = false; /// 개인정보 타일
  bool isExpanded2 = false; /// 서비스 이용약관 타일
  final String _dummy = '가나다라마바사가나다라마바사가나다라마바사가나다라마바사가나다라마바사가나다라마바사가나다라마바사가나다라마바사가나다라마바사가나다라마바사가나다라마바사';

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        automaticallyImplyLeading: false,
        backgroundColor: Colors.white,
        leading: IconButton(
          icon: Icon(Icons.arrow_back_ios),
            onPressed: () {
              Navigator.pop(context);
            }
        ),
      ),
      backgroundColor:Color(0xffF1F4F7),
      body: SingleChildScrollView(
        physics: const ClampingScrollPhysics(),
        child: Column(
          mainAxisAlignment: MainAxisAlignment.start,
          crossAxisAlignment: CrossAxisAlignment.start,
          children: [
            Container(
              width: Get.width,
              decoration: BoxDecoration(
                color: Colors.white,
                border: Border(
                  bottom: BorderSide(
                    color: Color(0xffE2E5E8), // 보더의 색상
                    width: 1.0,           // 보더의 두께
                  ),
                ),
              ),
              child: Padding(
                padding: const EdgeInsets.only(left: 20,bottom: 20,top: 16),
                child: Text('이용약관', style: f28w800Size(),),
              ),
            ),
            Padding(
              padding: const EdgeInsets.symmetric(horizontal: 20),
              child: Column(
                children: [
                  const SizedBox(height: 10,),
                  /// 개인정보 수집
                  Theme(
                  data: Theme.of(context).copyWith(
                    dividerColor: Colors.transparent,
                  ),
                  child: Container(
                    width: Get.width,
                    decoration: BoxDecoration(
                      color: Color(0xffFBFBFB),
                      borderRadius: BorderRadius.circular(4)
                    ),
                    child: ExpansionTile(
                      tilePadding: EdgeInsets.zero,
                      title: Padding(
                        padding: const EdgeInsets.only(left: 10),
                        child: Row(
                          children: [
                            GestureDetector(
                              onTap: () {
                                setState(() {
                                  isChecked = !isChecked;
                                  if(!isChecked) {
                                    isChecked3 = false;
                                  }
                                });
                              },
                              child: SvgPicture.asset(
                                isChecked ? 'assets/icon/check.svg' : 'assets/icon/uncheck.svg',
                                width: 26,
                                height: 26,
                              ),
                            ),
                            SizedBox(width: 10),
                            Row(
                              children: [
                                Text(
                                  '개인정보 수집 및 이용 ',
                                  style: f16w700Size()
                                ),
                                Text(
                                  '(필수)',
                                  style: f16w700Blue()
                                ),
                              ],
                            ),
                          ],
                        ),
                      ),
                      trailing: Padding(
                        padding: const EdgeInsets.only(right: 8),
                        child: IconTheme(
                          data: IconThemeData(color: Colors.black),
                          child: isExpanded2
                              ? SvgPicture.asset('assets/icon/upArrow.svg')
                              : SvgPicture.asset('assets/icon/downArrow.svg'),
                        ),
                      ),
                      onExpansionChanged: (value) {
                        setState(() {
                          isExpanded2 = value;
                        });
                      },
                      // initiallyExpanded: true,
                      children: [
                        Divider(color: Color(0xffF1F4F7),),
                        Container(
                          decoration: BoxDecoration(
                            color: Color(0xffFBFBFB),
                            borderRadius: BorderRadius.circular(8),
                          ),
                          child: Padding(
                            padding: const EdgeInsets.only(left: 20,right: 20,),
                            child: Container(
                              height: 250,
                              child: SingleChildScrollView(
                                physics: const ClampingScrollPhysics(),
                                child: Column(
                                  crossAxisAlignment: CrossAxisAlignment.start,
                                  children: [
                                    Text('이용 약관',style: f14w700Size(),),
                                    const SizedBox(height:10,),
                                    Text(
                                      '$_dummy$_dummy$_dummy$_dummy$_dummy$_dummy$_dummy$_dummy',
                                      style: TextStyle(
                                        fontFamily: 'Pretendard',
                                        fontSize: 14,
                                        fontWeight: FontWeight.w400,
                                      ),
                                    ),
                                  ],
                                ),
                              ),
                            ),
                          ),
                        ),
                      ],
                    ),
                  ),
                ),
                  const SizedBox(height: 8,),
                  /// 서비스 이용약관
                  Theme(
                    data: Theme.of(context).copyWith(
                      dividerColor: Colors.transparent,
                    ),
                    child: Container(
                      width: Get.width,
                      decoration: BoxDecoration(
                          color: Color(0xffFBFBFB),
                          borderRadius: BorderRadius.circular(4)
                      ),
                      child: ExpansionTile(
                        tilePadding: EdgeInsets.zero,
                        title: Padding(
                          padding: const EdgeInsets.only(left: 10),
                          child: Row(
                            children: [
                              GestureDetector(
                                onTap: () {
                                  setState(() {
                                    isChecked2 = !isChecked2;
                                    if(!isChecked2) {
                                      isChecked3 = false;
                                    }
                                  });
                                },
                                child: SvgPicture.asset(
                                  isChecked2 ? 'assets/icon/check.svg' : 'assets/icon/uncheck.svg',
                                  width: 26,
                                  height: 26,
                                ),
                              ),
                              SizedBox(width: 10),
                              Row(
                                children: [
                                  Text(
                                      '서비스 이용약관 동의 ',
                                      style: f16w700Size()
                                  ),
                                  Text(
                                      '(필수)',
                                      style: f16w700Blue()
                                  ),
                                ],
                              ),
                            ],
                          ),
                        ),
                        trailing: Padding(
                          padding: const EdgeInsets.only(right: 8),
                          child: IconTheme(
                            data: IconThemeData(color: Colors.black),
                            child: isExpanded
                                ? SvgPicture.asset('assets/icon/upArrow.svg')
                                : SvgPicture.asset('assets/icon/downArrow.svg'),
                          ),
                        ),
                        onExpansionChanged: (value) {
                          setState(() {
                            isExpanded = value;
                          });
                        },
                        // initiallyExpanded: true,
                        children: [
                          Divider(color: Color(0xffF1F4F7),),
                          Container(
                            decoration: BoxDecoration(
                              color: Color(0xffFBFBFB),
                              borderRadius: BorderRadius.circular(8),
                            ),
                            child: Padding(
                              padding: const EdgeInsets.only(left: 20,right: 20,),
                              child: Container(
                                height: 250,
                                child: SingleChildScrollView(
                                  physics: const ClampingScrollPhysics(),
                                  child: Column(
                                    crossAxisAlignment: CrossAxisAlignment.start,
                                    children: [
                                      Text('이용 약관',style: f14w700Size(),),
                                      const SizedBox(height:10,),
                                      Text(
                                        '$_dummy$_dummy$_dummy$_dummy$_dummy$_dummy$_dummy$_dummy',
                                        style: TextStyle(
                                          fontFamily: 'Pretendard',
                                          fontSize: 14,
                                          fontWeight: FontWeight.w400,
                                        ),
                                      ),
                                    ],
                                  ),
                                ),
                              ),
                            ),
                          ),
                        ],
                      ),
                    ),
                  ),

                  SizedBox(height: 20,),
                  Row(
                    mainAxisAlignment: MainAxisAlignment.end,
                    children: [
                      GestureDetector(
                        onTap: () {
                          setState(() {
                            isChecked3 = !isChecked3;
                            isChecked = isChecked3;
                            isChecked2 = isChecked3;
                          });
                        },
                        child: SvgPicture.asset(
                          isChecked3 ? 'assets/icon/check.svg' : 'assets/icon/uncheck.svg',
                          width: 26,
                          height: 26,
                        ),
                      ),
                      SizedBox(width: 10),
                      Text('모두 동의합니다',
                        style: TextStyle(
                          fontFamily: 'Pretendard',
                          fontSize: 18,
                          fontWeight: FontWeight.w700,
                        ),),
                    ],
                  ),],
              ),
            )
          ],
        ),
      ),
      bottomNavigationBar: GestureDetector(
        onTap: () {

          Get.to(() => PwChange());
        },
        child: Container(
          width: double.infinity,
          height: 60,
          decoration: BoxDecoration(
            color: Color(0xff1955EE),
          ),
          child: Center(
            child: Text(
              '비밀번호 변경',
              style: f20Whitew700Size(),
            ),
          ),
        ),
      ),
    );
  }

  // void goBootpayRequest(BuildContext context) async {
  //   Payload payload = Payload();
  //   payload.androidApplicationId = '64b76e0700be04001a77a553';
  //   payload.iosApplicationId = '64b76e0700be04001a77a554';
  //   payload.webApplicationId = '64b76e0700be04001a77a552';
  //
  //   payload.pg = 'danal';
  //   payload.method = 'auth';
  //   payload.orderName = '휴대폰 인증';
  //   payload.authenticationId = DateTime.now().millisecondsSinceEpoch.toString();
  //
  //   Extra extra = Extra();
  //   extra.appScheme = 'Hello-Research';
  //
  //   if (kIsWeb) {
  //     payload.extra?.openType = "iframe";
  //   }
  //
  //   Bootpay().requestAuthentication(
  //     context: context,
  //     payload: payload,
  //     showCloseButton: true,
  //     onClose: () {
  //       Bootpay().dismiss(context);
  //     },
  //     onDone: (String json) async {
  //       String receipt = jsonDecode(json)['data']['receipt_id'];
  //       String url = 'https://www.hello-research.com:3539/auth/${receipt}';
  //       http.Response response = await http.get(Uri.parse(url));
  //       try {
  //         var data = response.body;
  //         setState(() {
  //           _nameCon.text = jsonDecode(data)['authenticate_data']['name'].toString();
  //           _phoneCon.text = jsonDecode(data)['authenticate_data']['phone'].toString();
  //         });
  //       } catch (e) {
  //         _phoneCon.text = '';
  //         _nameCon.text = '';
  //         setState(() {});
  //       }
  //     },
  //     onCancel: (String json) {
  //       Get.back();
  //       // print('onCancel: $json');
  //     },
  //     onError: (String json) {
  //       // Get.back();
  //       print('onError: $json');
  //     },
  //   );
  // }
}
