import 'dart:async';
import 'dart:math';
import 'package:dropdown_button2/dropdown_button2.dart';
import 'package:flutter/material.dart';
import 'package:flutter_svg/flutter_svg.dart';
import 'package:get/get.dart';
import '../../components/color_radio.dart';
import '../../db/get_monitoring_info.dart';
import '../../provider/user_state.dart';
import '../util/font/font.dart';
import 'fire/firesettingTest.dart';

class MonitoringTestPage extends StatefulWidget {
  const MonitoringTestPage({Key? key}) : super(key: key);

  @override
  State<MonitoringTestPage> createState() => _MonitoringMainPageState();
}

class _MonitoringMainPageState extends State<MonitoringTestPage> {
  final us = Get.put(UserState());
  final TextEditingController _controller = TextEditingController();

  /// drop
  String? _selectedValue = '김나다 아파트';
  final List<String> _items = ['김나다 아파트', '떙떙 아파트', '아파트으'];

  bool _isLoading = true;
  List alimCheck = [];

  /// 소방수신기 알림

  /// 급수관 개폐 함수
  bool switchButton = false;

  void toggleValve() async {
    switchButton = !switchButton;
    String valveStatus = switchButton ? '열려있음' : '닫혀있음';

    await getInfo();
    setState(() {});
  }

  String decimalToHex(int decimalNumber) {
    String hex = decimalNumber.toRadixString(16).toUpperCase();
    if (hex.length == 1) {
      hex = '0' + hex;
    }
    return hex;
  }

  @override
  void initState() {
    alimCheck = List.generate(5, (index) => false);
    Future.delayed(Duration.zero, () async {
      await MonitoringInfo();
      // await getInfo(); ///소캣 정보 가져오기
      // socket.add
      // socket.listen((List<int> data) {
      //   String message = String.fromCharCodes(data).trim();
      //   print('수신된 데이터: $message');
      // },
      //   onDone: () {
      //     print('서버와의 연결이 종료되었습니다.');
      //     socket.destroy();
      //   },
      // );
      // await getInfo();
      _isLoading = false;
      setState(() {});
    });
    // /// 2초동안 서버에 데이터 넣는 곳
    // Timer.periodic(Duration(seconds: 2), (timer) {
    //   // String randomString = generateRandomString(8);
    //   // String randomString2 = generateRandomString(8);
    //   dataToSend = [
    //     0xc0, // Start
    //     0x0d, // Len
    //     0x10, // Packet Type
    //     0x05, 0x01, 0x00, 0x23, 0x05, 0x00, 0x2a, 0xb0, 0xda, 0x00, 0xe1, //Payload
    //     0xa8 // XOR
    //   ];
    //   socket.add(dataToSend);
    //         });
    super.initState();
  }

  String generateRandomString(int length) {
    const chars = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789';
    final random = Random();
    return List.generate(length, (index) => chars[random.nextInt(chars.length)]).join();
  }

  @override
  void dispose() {
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: PreferredSize(
        preferredSize: Size.fromHeight(52),
        child: AppBar(
          automaticallyImplyLeading: false,
          actions: [
            Container(
              width: Get.width,
              padding: const EdgeInsets.symmetric(vertical: 14),
              child: DropdownButtonHideUnderline(
                child: DropdownButton2<String>(
                  isExpanded: true,
                  // hint: Text('시간 선택', style: f14w500),
                  items: _items
                      .map((String item) => DropdownMenuItem<String>(
                            value: item,
                            child: Text('${item}', style: f20w700Size()),
                          ))
                      .toList(),
                  value: _selectedValue,
                  onChanged: (String? value) {
                    setState(() {
                      _selectedValue = value;
                    });
                  },
                  iconStyleData: const IconStyleData(
                    icon: Icon(
                      Icons.keyboard_arrow_down_outlined,
                    ),
                    iconSize: 20,
                    iconEnabledColor: Colors.black,
                    iconDisabledColor: Colors.black,
                  ),
                  buttonStyleData: const ButtonStyleData(
                    padding: EdgeInsets.symmetric(horizontal: 24),
                    height: 40,
                    width: 140,
                  ),
                  dropdownStyleData: DropdownStyleData(
                    maxHeight: 200,
                    decoration: BoxDecoration(),
                    offset: const Offset(0, -10),
                    scrollbarTheme: ScrollbarThemeData(
                      radius: const Radius.circular(40),
                      thickness: MaterialStateProperty.all(6),
                      thumbVisibility: MaterialStateProperty.all(true),
                    ),
                  ),
                ),
              ),
            ),
          ],
        ),
      ),
      body: _isLoading
          ? Container()
          : SingleChildScrollView(
              physics: const ClampingScrollPhysics(),
              child: Container(
                color: Color(0xffF1F4F7),
                child: Padding(
                  padding: const EdgeInsets.only(left: 10, right: 10, top: 20),
                  child: Column(
                    children: [

                      /// 저수조 수위
                      /// 29% 이하 또는 69% 이상일 경우에는 붉은 글씨
                      /// 오뚜기는 물 부족 경고 와 불 넘침 경고
                      Stack(
                        children: [
                          Positioned(
                            child: Container(
                                width: Get.width,
                                height: 135,
                                child: SvgPicture.asset(
                                  'assets/icon/water.svg',
                                  fit: BoxFit.fill,
                                )),
                          ),
                          Positioned.fill(
                            top: 20,
                            child: Align(
                                alignment: Alignment.topCenter,
                                child: Text(
                                  '저수조 수위',
                                  style: f18w700Size(),
                                )),
                          ),
                          Positioned.fill(
                            left: 20,
                            right: 20,
                            child: Column(
                              mainAxisAlignment: MainAxisAlignment.center,
                              crossAxisAlignment: CrossAxisAlignment.center,
                              children: [
                                Row(
                                  mainAxisAlignment: MainAxisAlignment.spaceBetween,
                                  children: [
                                    Text(
                                      '디지털계량기',
                                      style: f16w700Size(),
                                    ),
                                    Text(
                                      '오뚜기 센서',
                                      style: f16w700Size(),
                                    ),
                                  ],
                                ),
                                const SizedBox(
                                  height: 10,
                                ),
                              ],
                            ),
                          ),
                          Positioned.fill(
                            left: 30, // 3자리면 28
                            right: 32, // 정상 right 32 비정상 right 22
                            bottom: 20,
                            child: Column(
                              mainAxisAlignment: MainAxisAlignment.end,
                              crossAxisAlignment: CrossAxisAlignment.center,
                              children: [
                                Row(
                                  mainAxisAlignment: MainAxisAlignment.spaceBetween,
                                  children: [
                                    Text(
                                      '10%',
                                      style: 60 > 50 ? f28w700RedSize() : f28w700Size(),
                                    ),
                                    Text(
                                      '정상',
                                      style: 60 < 50 ? f28w700RedSize() : f28w700Size(),
                                    ),
                                  ],
                                )
                              ],
                            ),
                          )
                        ],
                      ),
                      const SizedBox(
                        height: 10,
                      ),

                      /// 집수정
                      GestureDetector(
                        behavior: HitTestBehavior.opaque,
                        onTap: () {},
                        child: Container(
                          width: Get.width,
                          height: 75,
                          decoration: BoxDecoration(color: Colors.white, borderRadius: BorderRadius.circular(20)),
                          child: Padding(
                            padding: const EdgeInsets.only(left: 20, right: 18),
                            child: Row(
                              mainAxisAlignment: MainAxisAlignment.start,
                              children: [
                                Text(
                                  '집수정',
                                  style: f18w700Size(),
                                ),
                                Spacer(),
                                BlueRadio(),
                                const SizedBox(
                                  width: 6,
                                ),
                                Text(
                                  '정상',
                                  style: bluef18w700(),
                                ),
                                const SizedBox(
                                  width: 14,
                                ),
                              ],
                            ),
                          ),
                        ),
                      ),
                      const SizedBox(
                        height: 10,
                      ),

                      /// 급수관 개폐
                      Container(
                          padding: const EdgeInsets.symmetric(horizontal: 20, vertical: 20),
                          decoration: BoxDecoration(borderRadius: BorderRadius.circular(20), color: Colors.white),
                          width: Get.width,
                          // height: 162,
                          child: Column(
                            crossAxisAlignment: CrossAxisAlignment.start,
                            mainAxisAlignment: MainAxisAlignment.center,
                            children: [
                              Text(
                                '급수밸브',
                                style: f14w600Size(),
                              ),
                              SizedBox(height: 10),
                              Row(
                                mainAxisAlignment: MainAxisAlignment.spaceBetween,
                                children: [
                                  GestureDetector(
                                      onTap:(){
                                        switchButton = true;
                                        setState(() {

                                        });
                                      },
                                      child: Text('열기', style: switchButton ? f16w700Size() : f16w600GreySize(),)),
                                  switchButton ? SvgPicture.asset(
                                    'assets/icon/valve_open.svg',
                                    width: 140,
                                    height: 48,
                                  ) :  SvgPicture.asset(
                                    'assets/icon/valve_closed.svg',
                                    width: 140,
                                    height: 48,
                                  ),
                                  GestureDetector(
                                      onTap:(){
                                        switchButton = false;
                                        setState(() {

                                        });
                                      },
                                      child: Text('닫기', style: !switchButton ? f16w700Size() : f16w600GreySize(),)),
                                ],
                              ),
                              // Align(
                              //   alignment: Alignment.center,
                              //   child: Text(
                              //     switchButton ? '열려있음' : '닫혀있음',
                              //     style: f21w700Size(),
                              //   ),
                              // ),
                              // SizedBox(height: 30),
                              // Container(
                              //   decoration: BoxDecoration(
                              //     border: Border(
                              //       top: BorderSide(color: Color(0xffC5C9CC)),
                              //     ),
                              //   ),
                              //   child: Padding(
                              //     padding: const EdgeInsets.symmetric(horizontal: 60),
                              //     child: Row(
                              //       mainAxisAlignment: MainAxisAlignment.center,
                              //       children: [
                              //         GestureDetector(
                              //           onTap: () async {
                              //             switchButton = true;
                              //             // await changeSwitch(switchButton,'급수관');
                              //             // socket.add(us.userSocketData.value);
                              //             setState(() {});
                              //           },
                              //           child: Text(
                              //             '밸브 열기',
                              //             style: switchButton ? f16w600Size() : f16w600GreySize(),
                              //           ),
                              //         ),
                              //         Spacer(),
                              //         Container(
                              //           height: 48,
                              //           child: VerticalDivider(
                              //             color: Color(0xffC5C9CC),
                              //             thickness: 1,
                              //           ),
                              //         ),
                              //         Spacer(),
                              //         GestureDetector(
                              //           onTap: () async {
                              //             switchButton = false;
                              //             // await changeSwitch(switchButton,'급수관');
                              //             // socket.add(us.userSocketData.value);
                              //             setState(() {});
                              //           },
                              //           child: Text(
                              //             '밸브 닫기',
                              //             style: switchButton ? f16w600Size() : f16w600GreySize(),
                              //           ),
                              //         ),
                              //       ],
                              //     ),
                              //   ),
                              // ),
                            ],
                          )),
                      const SizedBox(
                        height: 10,
                      ),
                      const SizedBox(
                        height: 10,
                      ),
                      GestureDetector(
                        behavior: HitTestBehavior.opaque,
                        onTap: () {
                          // socket.destroy();
                          Get.to(() => FireSetting2Screen())!.then((value) {
                            // Future.delayed(Duration.zero,()async{
                            //   await MonitoringInfo().then((value) async{
                            //     socket = await Socket.connect('220.89.248.140', 5161);
                            //     await getInfo(); ///소캣 정보 가져오기
                            //     socket.add(us.userSocketData.value);
                            //     // int decimalNumber = 30;
                            //     // String hexadecimalNumber = decimalToHex(decimalNumber);
                            //     // String hexString = '0x$hexadecimalNumber';
                            //     //
                            //     // ///주경종이 true 일떄
                            //     // if(bool.parse('${us.userMonitoring[0]['mainjong']}')){
                            //     //   alimCheck[1] = true;
                            //     // }
                            //     // /// 지구경종이 true 일때
                            //     // if(bool.parse('${us.userMonitoring[0]['subjong']}')){
                            //     //   alimCheck[2] = true;
                            //     // }
                            //     // /// 부저가 true 일때
                            //     // if(bool.parse('${us.userMonitoring[0]['buzzer']}')){
                            //     //   alimCheck[3] = true;
                            //     // }
                            //     // /// 사이렌이 true 일때
                            //     // if(bool.parse('${us.userMonitoring[0]['siren']}')){
                            //     //   alimCheck[4] = true;
                            //     // }
                            //     //
                            //     // String switchString = alimCheck.map((flag) => flag?'1':'0').join();
                            //     // String reversedString = switchString.substring(1).split('').reversed.join();
                            //     // print('??리버스 스위치 ${reversedString}');
                            //     // int decimalValue = int.parse(reversedString, radix: 2);
                            //     // String hexvalue = '0x${decimalValue.toRadixString(16).padLeft(2, '0')}';
                            //     //
                            //     // /// 급수관 개폐 true
                            //     // // if(bool.parse('${us.userMonitoring[0]['data']}')){
                            //     // //   dataToSend = [
                            //     // //     0xc0, // Start
                            //     // //     0x0d, // Len
                            //     // //     0x10, // Packet Type
                            //     // //     0x05, 0x01, 0x00, 0x23, 0x05, int.parse('${hexvalue}'), 0x1a, 0xb0, 0x00, 0x00, int.parse('${hexString}'), //Payload
                            //     // //     0xa8 // XOR
                            //     // //   ];
                            //     // // }
                            //     // // else{
                            //     // //   dataToSend = [
                            //     // //     0xc0, // Start
                            //     // //     0x0d, // Len
                            //     // //     0x10, // Packet Type
                            //     // //     0x05, 0x01, 0x00, 0x23, 0x05, int.parse('${hexvalue}'), 0x2a, 0xb0, 0x00, 0x00, int.parse('${hexString}'), //Payload
                            //     // //     0xa8 // XOR
                            //     // //   ];
                            //     // // }
                            //     // // socket.add(dataToSend);
                            //     _isLoading = false;
                            //     setState(() {});
                            //   });
                            //
                            // });
                          });
                        },
                        child: Container(
                          width: Get.width,
                          height: 75,
                          decoration: BoxDecoration(color: Colors.white, borderRadius: BorderRadius.circular(20)),
                          child: Padding(
                            padding: const EdgeInsets.only(left: 20, right: 18),
                            child: Row(
                              mainAxisAlignment: MainAxisAlignment.start,
                              children: [
                                Text(
                                  '소방수신기 상태',
                                  style: f18w700Size(),
                                ),
                                Spacer(),
                                BlueRadio(),
                                const SizedBox(
                                  width: 6,
                                ),
                                Text(
                                  '정상',
                                  style: bluef18w700(),
                                ),
                                const SizedBox(
                                  width: 14,
                                ),
                                SvgPicture.asset('assets/icon/rightArrow.svg')
                              ],
                            ),
                          ),
                        ),
                      ),
                      const SizedBox(
                        height: 32,
                      ),

                      /// 변압기 온도 , 변압기 주변 온도
                      Container(
                        width: Get.width,
                        child: Row(
                          mainAxisAlignment: MainAxisAlignment.center,
                          children: [
                            Spacer(),
                            Container(
                              child: Column(
                                crossAxisAlignment: CrossAxisAlignment.center,
                                children: [
                                  Text(
                                    '변압기 온도',
                                    style: grf14w600(),
                                  ),
                                  Row(
                                    children: [
                                      Text(
                                        '45',
                                        style: f28w700Size(),
                                      ),
                                      const SizedBox(
                                        width: 4,
                                      ),
                                      Text(
                                        '°C',
                                        style: f18w400Size(),
                                      )
                                    ],
                                  )
                                ],
                              ),
                            ),
                            Spacer(),
                            Container(
                              height: 38,
                              child: VerticalDivider(
                                color: Color(0xffC5C9CC),
                                thickness: 1,
                              ),
                            ),
                            Spacer(),
                            Container(
                              child: Column(
                                children: [
                                  Text(
                                    '변압기 온도',
                                    style: grf14w600(),
                                  ),
                                  Row(
                                    children: [
                                      Text(
                                        '25',
                                        style: f28w700Size(),
                                      ),
                                      const SizedBox(
                                        width: 4,
                                      ),
                                      Text(
                                        '°C',
                                        style: f18w400Size(),
                                      )
                                    ],
                                  )
                                ],
                              ),
                            ),
                            Spacer(),
                          ],
                        ),
                      ),

                      const SizedBox(
                        height: 10,
                      ),

                      /// 정화조 수위
                      GestureDetector(
                        behavior: HitTestBehavior.opaque,
                        onTap: () {},
                        child: Container(
                          width: Get.width,
                          height: 75,
                          decoration: BoxDecoration(color: Colors.white, borderRadius: BorderRadius.circular(20)),
                          child: Padding(
                            padding: const EdgeInsets.only(left: 20, right: 18),
                            child: Row(
                              mainAxisAlignment: MainAxisAlignment.start,
                              children: [
                                Text(
                                  '정화조 수위',
                                  style: f18w700Size(),
                                ),
                                Spacer(),
                                1 < 2 ? BlueRadio() : RedRadio(),
                                const SizedBox(
                                  width: 6,
                                ),
                                Text(
                                  1 < 2 ? '정상' :  '오수 넘침 경고',
                                  style: 1 < 2 ?bluef18w700() : redf18w700(),
                                ),
                                const SizedBox(
                                  width: 14,
                                ),
                              ],
                            ),
                          ),
                        ),
                      ),
                      const SizedBox(
                        height: 10,
                      ),
                      // Form(
                      //   child: TextFormField(
                      //     controller: _controller,
                      //     decoration: const InputDecoration(labelText: 'Send a message',labelStyle: TextStyle(color: Colors.black)),
                      //   ),
                      // ),
                      // Text(
                      //   snapshot.hasData
                      //       ? '${jsonDecode(String.fromCharCodes(snapshot.data!))[0]['data']}'
                      //       : '',
                      // ),
                      // Text(snapshot.hasData ? '${String.fromCharCodes(snapshot.data!).trim()}' : ''),
                      // GestureDetector(
                      //   onTap: ()async{
                      //     await getInfo();
                      //   },
                      //   child: Container(
                      //     width: Get.width,
                      //     height: 52,
                      //     color: greenColor,
                      //     child: Center(child: Text('수신기 상태 확인',style: f20Whitew700Size())),
                      //   ),
                      // )
                    ],
                  ),
                ),
              ),
            ),
    );
  }
// Future<void> getInfo() async {
//   List<int> dataToSend =[];
//   ///주경종이 true 일떄
//   if(bool.parse('${us.userMonitoring[0]['mainjong']}')){
//     alimCheck[1] = true;
//   }
//   /// 지구경종이 true 일때
//   if(bool.parse('${us.userMonitoring[0]['subjong']}')){
//     alimCheck[2] = true;
//   }
//   /// 부저가 true 일때
//   if(bool.parse('${us.userMonitoring[0]['buzzer']}')){
//     alimCheck[3] = true;
//   }
//   /// 사이렌이 true 일때
//   if(bool.parse('${us.userMonitoring[0]['siren']}')){
//     alimCheck[4] = true;
//   }
//
//   String switchString = alimCheck.map((flag) => flag?'1':'0').join();
//   String reversedString = switchString.substring(1).split('').reversed.join();
//   print('??리버스 스위치 ${reversedString}');
//   int decimalValue = int.parse(reversedString, radix: 2);
//   String hexvalue = '0x${decimalValue.toRadixString(16).padLeft(2, '0')}';
//
//
//   if(switchButton){
//     dataToSend = [
//       0xc0, // Start
//       0x0d, // Len
//       0x10, // Packet Type
//       0x05, 0x01, 0x00, 0x23, 0x05, int.parse('${hexvalue}'), 0x2a, 0xb0, 0x00, 0x00, 0x1e, //Payload
//       0xa8 // XOR
//     ];
//   }
//   else{
//     dataToSend = [
//       0xc0, // Start
//       0x0d, // Len
//       0x10, // Packet Type
//       0x05, 0x01, 0x00, 0x23, 0x05, int.parse('${hexvalue}'), 0x1a, 0xb0, 0x00, 0x00, 0x1e, //Payload
//       0xa8 // XOR
//     ];
//   }
//   socket.add(dataToSend);
// }

// Future<void> getInfo2() async {
//   print('in');
//   socket.writeln('${_controller.text}');
// }
}
