import 'package:flutter/material.dart';
import 'package:get/get.dart';
import '../../util/font/font.dart';

class PrivateChange extends StatefulWidget {
  const PrivateChange({Key? key}) : super(key: key);
  static final String id = '/private';

  @override
  State<PrivateChange> createState() => _PrivateChangeState();
}

class _PrivateChangeState extends State<PrivateChange> {
  final _titleL = [
    '관리자명',
    '소속',
    '구분',
    '전화번호',
    '이메일'
  ];

  final _dataL = [
    '${us.userList[0]['name']}',
    '${us.userList[0]['agency']}',
    '${us.userList[0]['head'] == 'true'?'주관리자':'일반'}',
    '${us.userList[0]['email']}',
    '1234@naver.com'
  ];


  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text('개인정보 변경',style: f16w900Size(),),
        centerTitle: true,
        shape: Border(
          bottom: BorderSide(
            color:  const Color(0xffEFF0F0),
            width: 1,
          ),
        ),
      ),
      backgroundColor: const Color(0xffF1F4F7),
      body: Padding(
        padding: const EdgeInsets.only(top: 10),
        child: Column(
          children: [
            ListView.builder(
                shrinkWrap: true,
                itemCount: 5,itemBuilder: (_,index){
              return Column(
                children: [
                  Container(
                    width: Get.width,
                    padding: const EdgeInsets.symmetric(horizontal: 20,vertical: 16),
                    color: Colors.white,
                    child: Row(
                      children: [
                        Text(_titleL[index],style: f16w400Size(),),
                        Spacer(),
                        Text(_dataL[index],style: f16w800GreySize(),),
                        index == 3 || index == 4 ? GestureDetector(
                          onTap: (){
                            if(index==3){
                              print('전화번호 변경');
                            }
                            else{

                            }
                          },
                          child: Container(
                            margin: const EdgeInsets.only(left: 8),
                            padding: const EdgeInsets.symmetric(horizontal: 10,vertical: 4),
                            decoration: BoxDecoration(
                              border: Border.all(color: const Color(0xff1955EE)),
                              borderRadius: BorderRadius.circular(100),
                            ),
                            child: Text('변경',style: f13w400BlueSize(),),
                          ),
                        ) : SizedBox()
                      ],
                    ),
                  ),
                  const SizedBox(height: 1,)
                ],
              );
            }),
           // const SizedBox(height: 10 ,),
            Container(
              width: Get.width,
              padding: const EdgeInsets.symmetric(horizontal: 20,vertical: 16),
              color: Colors.white,
              child: Row(
                children: [
                  Text('탈퇴하기',style: f16w400RedSize(),),
                ],
              ),
            ),
          ],
        ),
      ),
    );
  }
}
