import 'package:flutter/material.dart';
import 'package:get/get.dart';

import 'components/snack.dart';

class Test1 extends StatefulWidget {
  const Test1({Key? key}) : super(key: key);

  @override
  State<Test1> createState() => _Test1State();
}

class _Test1State extends State<Test1> {
  Offset _position = Offset(0.0, 0.0); /// 빨간색
  Offset _position2 = Offset(0.0, 0.0); /// 파란색
  bool check1 = false; /// 점1버튼 클릭
  bool check2 = false; /// 점2버튼 클릭
  double redValue = 0.0;
  double greenValue = 0.0;
  bool resultValue = false; /// 설정하기 누르기
  bool resultValue2 = false; /// 설정하기 누르기 설정이 완료되면 true로 바뀜
  /// 거리 계산

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text('사진 정밀 검사'),
        backgroundColor: Colors.blue,
      ),
      body: GestureDetector(
        onPanUpdate: (details){
          if(check1||check2){
            updatePosition(details.delta.dy);
          }
        },
        child: Stack(
          children: [
            Positioned(
              child: Container(
                width: Get.width,
                height: Get.height,
                child: Image.asset(
                  'assets/2.jpeg',
                  fit: BoxFit.none,
                  // fit: BoxFit.cover, // 이거하면 화면 꽉차긴 함(둘 중에 하나 선택)
                ),
              ),),
            resultValue
                ? Positioned(
              top: _position.dy,
              left: Get.width * 0.5 - 8,
                  child: Container(
              padding: EdgeInsets.all(8.0),
              decoration: BoxDecoration(
                  shape: BoxShape.circle,
                  color: Colors.red,
              ),
            ),
                )
                : check1
               ? Positioned(
             top: _position.dy,
             left: Get.width * 0.5 - 8,
             child: Draggable(
               data: '323',
               hitTestBehavior: HitTestBehavior.opaque,
               child: Container(
                 padding: EdgeInsets.all(8.0),
                 decoration: BoxDecoration(
                   shape: BoxShape.circle,
                   color: Colors.red,
                 ),
               ),
               feedback: Container(
                 padding: EdgeInsets.all(8.0),
                 decoration: BoxDecoration(
                   shape: BoxShape.circle,
                   color: Colors.red,
                 ),
               ),
               childWhenDragging: Container(),
               onDragUpdate: (details) {
                 _position = Offset(
                   Get.width * 0.5 - 8,
                   _position.dy + details.delta.dy,
                 );
                 redValue =  _position.dy + details.delta.dy;
                 /// 제한두는 코드
                 _position = Offset(
                   _position.dx,
                   _position.dy.clamp(
                     MediaQuery.of(context).padding.top,
                     Get.height*0.7,
                   ),
                 );

                 setState(() {});
               },
               // onDraggableCanceled: (velocity, offset) {
               //   setState(() {
               //     _position = offset;
               //   });
               // },
             ),
           )
               : Container(),
            resultValue2
                ? Positioned(
                top: _position2.dy,
                left: Get.width * 0.5 - 8,
                child: Container(
              padding: EdgeInsets.all(8),
              decoration: BoxDecoration(
                shape: BoxShape.circle,
                color: Colors.green,
              ),
            ))
                : check2
                ? Positioned(
                 top: _position2.dy,
                 left: Get.width * 0.5 - 8,
                  child: Draggable(
                    child: Container(
                  padding: EdgeInsets.all(8),
                  decoration: BoxDecoration(
                    shape: BoxShape.circle,
                    color: Colors.green,
                  ),
                ),
                feedback: Container(
                  padding: EdgeInsets.all(8.0),
                  decoration: BoxDecoration(
                    shape: BoxShape.circle,
                    color: Colors.green,
                  ),
                ),
                childWhenDragging: Container(),
                onDragUpdate: (details) {
                  _position2 = Offset(
                    Get.width * 0.5 - 8,
                    _position2.dy + details.delta.dy,
                  );
                  greenValue =  _position2.dy + details.delta.dy;
                  _position2 = Offset(
                    _position2.dx,
                    _position2.dy.clamp(
                      MediaQuery.of(context).padding.top - 50.0,
                      Get.height*0.7,
                    ),
                  );
                  setState(() {});
                },
                // onDraggableCanceled: (velocity, offset) {
                //   setState(() {
                //     _position = offset;
                //   });
                // },
              ),
            )
                : Container(),
            resultValue&&resultValue2
                ?Positioned(
              child: Align(
                alignment: Alignment.bottomCenter,
                child: Padding(
                  padding: const EdgeInsets.only(bottom: 50),
                  child: Container(
                      child: Text('결과값 ?? ${(greenValue - redValue).floor()}')
                  ),
                ),
              ),)
                :Container(),
          ],
        ),
      ),
      bottomNavigationBar: Padding(
        padding: EdgeInsets.only(bottom: MediaQuery.of(context).viewInsets.bottom),
        child: Container(
          padding: const EdgeInsets.symmetric(vertical: 32, horizontal: 50),
          child: Row(
            mainAxisAlignment: MainAxisAlignment.spaceBetween,
            children: [
              /// 점1 버튼
              GestureDetector(
                onTap: () {
                  if(check2){
                    check2 = false;
                  }
                  check1  = true;
                  resultValue = false;
                  setState(() {});
                },
                child: Container(
                    width: 52,
                    height: 24,
                    decoration: BoxDecoration(
                      border: Border.all(color: Colors.black),
                      color: check1?Colors.blue:Colors.transparent
                    ),
                    child: Text('점 1',textAlign: TextAlign.center,)),
              ),

              AnimatedCrossFade(
                duration: const Duration(milliseconds: 200),
                crossFadeState: check1||check2 ? CrossFadeState.showFirst : CrossFadeState.showSecond,
                firstChild: Padding(
                  padding: const EdgeInsets.only(right: 8),
                  child: GestureDetector(
                      onTap: (){
                        if(check1){
                          resultValue = true;
                          check1 = false;
                          setState(() {});
                        }
                        if(check2){
                          resultValue2 = true;
                          check2 = false;
                          setState(() {});
                        }
                        CustomSnackbar.show(context, '설정이 적용되었습니다.');
                      },
                      child: Text('설정하기')),
                ),
                secondChild: SizedBox()
              ),
              AnimatedCrossFade(
                  duration: const Duration(milliseconds: 200),
                  crossFadeState: check1||check2 ? CrossFadeState.showFirst : CrossFadeState.showSecond,
                  firstChild: Padding(
                    padding: const EdgeInsets.only(right: 8),
                    child: GestureDetector(
                        onTap: (){
                          if(check1 == true){
                            check1 = false;
                            resultValue = false;
                            _position = Offset(0.0, 0.0);
                          }else if(check2){
                            check2 = false;
                            resultValue2 = false;
                            _position2 = Offset(0.0, 0.0);
                          }
                          setState(() {});
                        },
                        child: Text('취소하기')),
                  ),
                  secondChild: SizedBox()
              ),

              /// 점2 버튼
              GestureDetector(
                onTap:(){
                  if(check1){
                    check1 = false;
                  }
                  check2  = true;
                  resultValue2 = false;
                  setState(() {});
                },
                child: Container(
                    width: 52,
                    height: 24,
                    decoration: BoxDecoration(
                        border: Border.all(color: Colors.black),
                        color: check2?Colors.blue:Colors.transparent
                    ),
                    child: Text('점 2',textAlign: TextAlign.center,)),
              )
            ],
          ),
        ),
      ),
    );
  }

  /// 위치 업데이트 메서드
  void updatePosition(double globalPosition) {
    if(check1){
      _position = Offset( Get.width * 0.5 - 8, _position.dy + globalPosition);
      redValue =  _position.dy + globalPosition;
      /// 제한하는 코드
      _position = Offset(
        _position.dx,
        _position.dy.clamp(
          MediaQuery.of(context).padding.top,
          Get.height*0.7,
        ),
      );
    }
    else{
      _position2 = Offset( Get.width * 0.5 - 8, _position2.dy + globalPosition);
      greenValue =  _position2.dy + globalPosition;
      /// 제한하는 코드
      _position2 = Offset(
        _position2.dx,
        _position2.dy.clamp(
          MediaQuery.of(context).padding.top,
          Get.height*0.7,
        ),
      );
    }
    setState(() {});
  }
}
